@doc generic_solver_docstring(
    "A 5 parallel, 2 processor method of 5th order.",
    "KuttaPRK2p5",
    "Explicit Runge-Kutta Method",
    """@article{jackson1995potential,
    title={The potential for parallelism in Runge--Kutta methods. Part 1: RK formulas in standard form},
    author={Jackson, Kenneth R and Norsett, Syvert Paul},
    journal={SIAM journal on numerical analysis},
    volume={32},
    number={1},
    pages={49--82},
    year={1995},
    publisher={SIAM}}""",
    "- `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.",
    "thread = OrdinaryDiffEq.True(),"
)
Base.@kwdef struct KuttaPRK2p5{TO} <: OrdinaryDiffEqAlgorithm
    threading::TO = true
end

@cache struct KuttaPRK2p5Cache{uType, rateType, TabType} <: OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    k::rateType
    k1::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5_6::Array{rateType, 1}
    tmp::uType
    fsalfirst::rateType
    tab::TabType
end
get_fsalfirstlast(cache::KuttaPRK2p5Cache, u) = (cache.fsalfirst, cache.k)

struct KuttaPRK2p5ConstantCache{T, T2} <: OrdinaryDiffEqConstantCache
    α21::T
    α31::T
    α32::T
    α41::T
    α42::T
    α43::T
    α5_6::Array{T, 2}
    β1::T
    β3::T
    β5::T
    β6::T
    c2::T2
    c3::T2
    c4::T2
    c5_6::Array{T2, 1}

    function KuttaPRK2p5ConstantCache(T, T2)
        α21 = T(1 // 3)
        α31 = T(4 // 25)
        α32 = T(6 // 25)
        α41 = T(1 // 4)
        α42 = T(-3)
        α43 = T(15 // 4)

        α5_6 = Array{T}(undef, (2, 4))
        α5_6[1, 1] = T(6 // 81)
        α5_6[1, 2] = T(90 // 81)
        α5_6[1, 3] = T(-50 // 81)
        α5_6[1, 4] = T(8 // 81)
        α5_6[2, 1] = T(6 // 75)
        α5_6[2, 2] = T(36 // 75)
        α5_6[2, 3] = T(10 // 75)
        α5_6[2, 4] = T(8 // 75)

        β1 = T(23 // 192)
        β3 = T(125 // 192)
        β5 = T(-81 // 192)
        β6 = T(125 // 192)
        c2 = T2(1 // 3)
        c3 = T2(2 // 5)
        c4 = T2(1)
        c5_6 = Array{T2}(undef, 2)
        c5_6[1] = T2(2 // 3)
        c5_6[2] = T2(4 // 5)
        return new{T, T2}(
            α21, α31, α32, α41, α42, α43, α5_6, β1, β3, β5, β6, c2, c3, c4,
            c5_6
        )
    end
end

function alg_cache(
        alg::KuttaPRK2p5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    k5_6 = Array{typeof(rate_prototype)}(undef, 2)
    k5_6[1] = zero(rate_prototype)
    k5_6[2] = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = KuttaPRK2p5ConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
    return KuttaPRK2p5Cache(u, uprev, k, k1, k2, k3, k4, k5_6, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::KuttaPRK2p5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return KuttaPRK2p5ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

module OrdinaryDiffEqPRK

import OrdinaryDiffEqCore: OrdinaryDiffEqAlgorithm, alg_order, OrdinaryDiffEqMutableCache,
    OrdinaryDiffEqConstantCache, constvalue, @cache,
    alg_cache, get_fsalfirstlast,
    unwrap_alg, perform_step!, @threaded, initialize!, isthreaded,
    full_cache, generic_solver_docstring
import MuladdMacro: @muladd
import FastBroadcast: @..
using Polyester

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("prk_caches.jl")
include("prk_perform_step.jl")

export KuttaPRK2p5

end

function initialize!(integrator, cache::KuttaPRK2p5ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(
        integrator, cache::KuttaPRK2p5ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; α21, α31, α32, α41, α42, α43, α5_6) = cache
    (; β1, β3, β5, β6, c2, c3, c4, c5_6) = cache

    k1 = f(uprev, p, t)
    k2 = f(uprev + dt * α21 * k1, p, t + c2 * dt)
    k3 = f(uprev + dt * (α31 * k1 + α32 * k2), p, t + c3 * dt)
    k4 = f(uprev + dt * (α41 * k1 + α42 * k2 + α43 * k3), p, t + c4 * dt)

    k5_6 = Array{typeof(k1)}(undef, 2)

    if !isthreaded(alg.threading)
        k5_6[1] = f(
            uprev +
                dt *
                (α5_6[1, 1] * k1 + α5_6[1, 2] * k2 + α5_6[1, 3] * k3 + α5_6[1, 4] * k4),
            p, t + c5_6[1] * dt
        )
        k5_6[2] = f(
            uprev +
                dt *
                (α5_6[2, 1] * k1 + α5_6[2, 2] * k2 + α5_6[2, 3] * k3 + α5_6[2, 4] * k4),
            p, t + c5_6[2] * dt
        )
    else
        let
            @threaded alg.threading for i in [1, 2]
                k5_6[i] = f(
                    uprev +
                        dt * (
                        α5_6[i, 1] * k1 + α5_6[i, 2] * k2 + α5_6[i, 3] * k3 +
                            α5_6[i, 4] * k4
                    ),
                    p,
                    t + c5_6[i] * dt
                )
            end
        end
    end

    u = uprev + dt * (β1 * k1 + β3 * k3 + β5 * k5_6[1] + β6 * k5_6[2])
    k = f(u, p, t + dt)

    integrator.fsallast = k # For interpolation, then FSAL'd
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

function initialize!(integrator, cache::KuttaPRK2p5Cache)
    (; k, fsalfirst) = cache
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::KuttaPRK2p5Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; k, k1, k2, k3, k4, k5_6, fsalfirst, tmp) = cache
    (; α21, α31, α32, α41, α42, α43, α5_6) = cache.tab
    (; β1, β3, β5, β6, c2, c3, c4, c5_6) = cache.tab

    f(k1, uprev, p, t)

    @.. broadcast = false u = uprev + dt * α21 * k1
    f(k2, u, p, t + c2 * dt)

    @.. broadcast = false u = uprev + dt * (α31 * k1 + α32 * k2)
    f(k3, u, p, t + c3 * dt)

    @.. broadcast = false u = uprev + dt * (α41 * k1 + α42 * k2 + α43 * k3)
    f(k4, u, p, t + c4 * dt)

    if !isthreaded(alg.threading)
        @.. broadcast = false u = uprev +
            dt * (
            α5_6[1, 1] * k1 + α5_6[1, 2] * k2 + α5_6[1, 3] * k3 +
                α5_6[1, 4] * k4
        )
        f(k5_6[1], u, p, t + c5_6[1] * dt)

        @.. broadcast = false u = uprev +
            dt * (
            α5_6[2, 1] * k1 + α5_6[2, 2] * k2 + α5_6[2, 3] * k3 +
                α5_6[2, 4] * k4
        )
        f(k5_6[2], u, p, t + c5_6[2] * dt)
    else
        tmps = (u, tmp)
        let
            @threaded alg.threading for i in [1, 2]
                @.. broadcast = false tmps[i] = uprev +
                    dt * (
                    α5_6[i, 1] * k1 + α5_6[i, 2] * k2 +
                        α5_6[i, 3] * k3 + α5_6[i, 4] * k4
                )
                f(k5_6[i], tmps[i], p, t + c5_6[i] * dt)
            end
        end
    end

    @.. broadcast = false u = uprev + dt * (β1 * k1 + β3 * k3 + β5 * k5_6[1] + β6 * k5_6[2])
    f(k, u, p, t + dt)
end

# This definitely needs cleaning
using OrdinaryDiffEqPRK, ODEProblemLibrary, DiffEqDevTools
using Test, Random
Random.seed!(100)

dts2 = 1 .// 2 .^ (7:-1:3)
testTol = 0.2

@testset "Explicit Solver Convergence Tests ($(["out-of-place", "in-place"][i]))" for i in 1:2
    prob = (
        ODEProblemLibrary.prob_ode_linear,
        ODEProblemLibrary.prob_ode_2Dlinear,
    )[i]
    sim3 = test_convergence(dts2, prob, KuttaPRK2p5(threading = true))
    @test sim3.𝒪est[:l∞] ≈ 5 atol = testTol

    sim3 = test_convergence(dts2, prob, KuttaPRK2p5(threading = false))
    @test sim3.𝒪est[:l∞] ≈ 5 atol = testTol
end
